// Athlete.cpp
//

#include "Athlete.h"
#include <iostream>
#include <cstdlib>

Athlete::Athlete (std::string name): Boxer(name){
	headHeight=0;
	eyesOnOpponent=true;
	this->remote = remote;
	leftGuard_=true;
	rightGuard_=true;
	leftPunching_=false;
	rightPunching_=false;
	hit_=false;
	pressedQuit_=false;
	remote=NULL;
}

void Athlete::acceptExporter(const DataVisitor &visitor){
	//visitor.exportUserBoxer(*this);
}
const BoxerPose* Athlete::getPose() const{
	return &pose;
}

bool Athlete::pressedQuit(){
	return pressedQuit_;
}

void Athlete::init(){
	remote=new wiimote();

	bool wiiConnected = false;

	for(int i=0; i<5; i++) {
		std::cout << "Connection to Wii Remote, press enter to skip." << endl;
		wiiConnected=remote->Connect(wiimote::FIRST_AVAILABLE);
		if(wiiConnected){
			remote->SetLEDs(0x0f);// light all LEDs
			break;
		}
		if(GetAsyncKeyState(VK_RETURN)){
			break;
		}

		Beep(500, 30); 
		Sleep(2000);
	}

	remote->SetReportType(wiimote::IN_BUTTONS_ACCEL_IR_EXT); // no IR dots
	remote->EnableMotionPlus();

	if(!wiiConnected){
		delete remote;
		remote=NULL;
	}
}


void Athlete::updateInfoFromMarker(bool eyesOnOpponent, int headHeight){
	leftPunching_=false;
	rightPunching_=false;
	pose.leftPunching_=false;
	pose.rightPunching_=false;
	if(remote){
		// the wiimote state needs to be refreshed for each pass
		if(remote->RefreshState() == NO_CHANGE){
			Sleep(10); // Don't hog the CPU if nothing changed
		}
		if(remote->ConnectionLost()){
			Beep(100, 1000);
			remote=NULL;
		}else{

			/*if(remote.Button.A()){
				trainer.clearFeedback();
			}*/
			remote->SetRumble(hit_);

			if(remote->Button.Home()){
				pressedQuit_=true;
			}

			leftGuard_=false;
			rightGuard_=false;
			if(remote->Acceleration.Z > remote->Nunchuk.Acceleration.Z){
				if(remote->Acceleration.Z > 3){
					rightPunching_=true;
					std::cout << "rightPunching" << endl;
				}
			}else{
				if(remote->Nunchuk.Acceleration.Z > 2){
					leftPunching_=true;
					std::cout << "leftPunching" << endl;
				}
			}

			if(remote->Acceleration.Orientation.Pitch >70 && remote->Acceleration.Orientation.Pitch<130){
				//	&& remote->Acceleration.Orientation.Roll < 75 && remote->Acceleration.Orientation.Roll > -75){
				rightGuard_ = true;
			}
			if(remote->Nunchuk.Acceleration.Orientation.Pitch >30 && remote->Nunchuk.Acceleration.Orientation.Pitch<90){
				//	&& remote->Nunchuk.Acceleration.Orientation.Roll < 75 && remote->Nunchuk.Acceleration.Orientation.Roll > -75){
				leftGuard_ = true;
			}
		}

	}
	if(GetAsyncKeyState(VK_ESCAPE)){
		pressedQuit_=true;
	}

	if(GetAsyncKeyState(VK_F1)){
		leftPunching_=true;
	}		
	if(GetAsyncKeyState(VK_F2)){
		rightPunching_=true;
	}				
	if(GetAsyncKeyState(VK_F3)){
		rightGuard()?rightGuard_=false:rightGuard_=true;
	}		
	if(GetAsyncKeyState(VK_F4)){
		leftGuard()?leftGuard_=false:leftGuard_=true;
	}		

	this->headHeight = headHeight;
	if(headHeight> height){
		height=headHeight;
	}
	this->eyesOnOpponent = eyesOnOpponent;

	pose.hit_=hit();
	pose.rightGuard_=rightGuard();
	pose.leftGuard_=leftGuard();
	pose.rightPunching_=rightPunching();
	pose.leftPunching_=leftPunching();
	pose.eyesOnOpponent = eyesOnOpponent;
	pose.height=headHeight;

	pose.setChanged();
	pose.notifyObservers(NULL);

	setChanged();
	this->notifyObservers(NULL);
}

Athlete::~ Athlete ()
{
	if(remote){
		remote->Disconnect();
		delete remote;
	}
}
