// Boxer.h
//

#ifndef Boxer_h
#define Boxer_h
#include "Observable.h"
#include <string>

class DataVisitor;
class BoxerPose;

class Boxer: public Observable{
protected:
  std::string const name;
public:
  bool leftGuard_;
  bool rightGuard_;
  bool leftPunching_;
  bool rightPunching_;
  bool hit_;
  Boxer (std::string name);

  virtual const BoxerPose* getPose() const=0;
  virtual bool leftGuard() const;
  virtual bool rightGuard () const;
  virtual bool leftPunching () const;
  virtual bool rightPunching () const;
  virtual bool hit () const;
  virtual const std::string& getName () const;
  virtual void acceptExporter(const DataVisitor &visitor)=0;
  virtual ~Boxer ();
};
#endif
