// Trainer.h
//

#ifndef Trainer_h
#define Trainer_h
#include "Observer.h"
#include "UserBoxerPose.h"
#include "Boxer.h"
#include "TrainerPose.h"
#include <string>
#include <list>
#include <time.h>

class DataVisitor;

class Trainer : public Observer, public Boxer{
protected:
	struct PlayerData{
		PlayerData() {}
		PlayerData(bool in_leftGuard, bool in_rightGuard, bool in_eyesOnOpponent) {
		  leftGuard = in_leftGuard;
		  rightGuard = in_rightGuard;
		  eyesOnOpponent = in_eyesOnOpponent;
		}
		bool leftGuard;
		bool rightGuard;
		bool eyesOnOpponent;
	};
	std::list <PlayerData> playerDataSet;
	std::list <TrainerPose> playerHistory;
	std::string feedback;
	double hitTime;
	double punchTime;
public:
	virtual const BoxerPose* getPose() const;
	TrainerPose pose;
	Trainer (std::string name);
	virtual const std::string& getFeedback () const;
	virtual void clearFeedback ();
	virtual void update (Observable * o, Argument * arg);
	virtual void acceptExporter(const DataVisitor &visitor);
	virtual ~ Trainer ();
};
#endif
