#pragma once
#include <osg/Billboard>
#include <osg/Texture2D>
#include "Trainer/Observer.h"

class TrainerAnimation: public Observer{
public:
	osg::Geode *getGeode();
	TrainerAnimation(void);
	virtual void init();
	osg::Drawable * createSquare (osg::Vec3 const & corner, osg::Vec3 const & width, osg::Vec3 const & height, osg::Image * image = NULL);
	virtual void update (Observable * o, Argument * arg);
	virtual ~TrainerAnimation(void);
protected:
	osg::Billboard *billboard;
	osg::Image *billboardImage;
	osg::Image *reset;
	osg::Image *leftPunching;
	osg::Image *rightPunching;
	osg::Image *leftGuardDown;
	osg::Image *rightGuardDown;
	osg::Image *leftGuardDownAndHit;
	osg::Image *rightGuardDownAndHit;
	osg::Drawable *quadImage;
	osg::StateSet* stateset;
};
